import java.lang.Math;

public class Aufgabe4 {

    /*
        Welche Werte kann man in einem Array vom Typ int[] abspeichern?

            Integer von Integer.MIN_VALUE bis einschließlich Integer.MAX_VALUE.

        Warum sind bei dieser Aufgabe Arrays hilfreich?

            Arrays ermöglichen, dass man nicht für jeden Wert, den man speichern möchte, eine eigene Variable benötigt.
            Da hier u. U. einige tausend Werte generiert und geprüft werden sollen, ist die Verwendung eines Arrays
            unumgänglich.

        Wie würden Sie diese Aufgabe ohne Arrays lösen?

            Ohne Arrays und ohne dynamische Datenstruktur könnte man die Aufgabe in dieser Form nur lösen,
            in dem man mehrere Variablen deklariert. D.h. jedes Element des Arrays wäre eine Variable. Ansonsten
            könnte man auf eine dynamische Datenstruktur wie LinkedList zurückgreifen.
     */

    /**
     * Fills an array zahlen with random numbers between 0 and N. Both 0 and N can be part of the array.
     *
     * @param zahlen Array in which the generated numbers will be stored.
     * @param N Biggest random number that should be generated.
     */
    private static void befuelleArray(int[] zahlen, int N) {
        for (int i = 0; i < zahlen.length; i++) {
            zahlen[i] = (int) (Math.random() * (N + 1));
        }
    }

    /**
     * Generate statistics for an array of numbers.
     *
     * It is checked how often a number is part of the array. Statistics are generated for all numbers between 0
     * and N, both bounds are included.
     *
     * @param zahlen Array for which statistics are generated.
     * @param N Numbers between including 0 and including N are checked.
     */
    private static void generiereStatistik(int[] zahlen, int N) {
        int count = 0;

        for (int i = 0; i <= N; i++) {
            count = 0;
            for (int zahl : zahlen) {
                if (zahl == i) {
                    count ++;
                }
            }
            System.out.println("Zahl " + i + " kommt " + count + "x vor");
        }
    }

    public static void main(String[] args) {
        int n = 4;
        int[] arr = new int[10];
        befuelleArray(arr, n);
        generiereStatistik(arr, n);
    }

}
