public class Aufgabe5 {

    /*
        Wie werden zweidimensionale Arrays in Java vom Aufbau her realisiert?

            Als ein Array, dessen einzelne Elemente wieder auf ein Array verweisen.

        Kann man auch mehrdimensionale (3 oder mehr Dimensionen) Arrays in Java anlegen?
        Wenn ja, geben Sie ein Beispiel für eine Deklaration an!

            Ja.

            int[][][] = new int[N][N][N];
     */

    /**
     * Creates an array with two dimensions (N * N) and fills it with numbers from 0 to N (excluded).
     *
     * @param N
     * @return two dimensional array
     */
    private static int[][] generiereMatrix(int N) {
        int[][] matrix = new int[N][N];
        int k = 0;

        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                matrix[i][j] = k++;
            }
        }

        return matrix;
    }

    /**
     * Prints a matrix to stdout.
     *
     * @param matrix Matrix to print to stdout.
     */
    private static void printMatrix(int[][] matrix) {
        for (int i = 0; i < matrix.length; i++) {
            for (int j = 0; j < matrix[i].length; j++) {
                System.out.print(matrix[i][j] + " ");
            }
            System.out.println();
        }
    }

    /**
     * Transponates a matrix, i.e. mirrors it on it's diagonal.
     *
     * @param matrix Matrix to transponate
     */
    private static void transponiereMatrix(int[][] matrix) {
        for (int i = 0; i < matrix.length; i++) {
            for (int j = i + 1; j < matrix[i].length; j++) {
                int swap = matrix[i][j];
                matrix[i][j] = matrix[j][i];
                matrix[j][i] = swap;
            }
        }
    }

    public static void main(String[] args) {
        int n = 3;
        int[][] matrix = generiereMatrix(n);
        printMatrix(matrix);
        transponiereMatrix(matrix);
        printMatrix(matrix);
    }

}
